<template>
  <div class="app-container">
    <!--    <el-form :model="queryParams" @submit.native.prevent ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">-->
    <!--      <el-form-item label="组合单号" prop="combinationCode">-->
    <!--        <el-input-->
    <!--          v-model="queryParams.combinationCode"-->
    <!--         -->
    <!--          clearable-->
    <!--          @keyup.enter.native="handleQuery"-->
    <!--        />-->
    <!--      </el-form-item>-->
    <!--      <el-form-item label="生产工单" prop="workorderCode">-->
    <!--        <el-input-->
    <!--          v-model="queryParams.workorderCode"-->
    <!--         -->
    <!--          clearable-->
    <!--          @keyup.enter.native="handleQuery"-->
    <!--        />-->
    <!--      </el-form-item>-->
    <!--      <el-form-item label="销售订单号" prop="salesOrderNumber">-->
    <!--        <el-input-->
    <!--          v-model="queryParams.salesOrderNumber"-->
    <!--         -->
    <!--          clearable-->
    <!--          @keyup.enter.native="handleQuery"-->
    <!--        />-->
    <!--      </el-form-item>-->
    <!--      <el-form-item>-->
    <!--        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">{{ $t('common.search') }}</el-button>-->
    <!--        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">{{ $t('common.reset') }}</el-button>-->
    <!--      </el-form-item>-->
    <!--    </el-form>-->

    <el-row v-if="showBtn" :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-plus"
          size="mini"
          :disabled="multiple"
          @click="handleCombination"
          v-hasPermi="['pro:combination:add']"
        >{{$t('拆分为组合单')}}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['pro:combination:add']"
        >{{$t('新增')}}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['pro:combination:edit']"
        >{{$t('修改')}}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['pro:combination:remove']"
        >{{$t('删除')}}</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['pro:combination:export']"
        >{{$t('导出')}}</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="combinationList" @selection-change="handleSelectionChange">

      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column :label="$t('组合单号')" align="center" prop="combinationCode"/>
      <el-table-column :label="$t('role.idx')" width="150" align="center" prop="combinationSort">
        <template slot-scope="scope">
          <el-input-number v-model="scope.row.combinationSort" @change="handleChangeSort(scope.row)" :min="0"
                           style="width: 140px"
                           :label="$t('role.idx')"></el-input-number>
        </template>
      </el-table-column>
      <el-table-column :label="$t('生产工单')" align="center" prop="workorderCode"/>
      <!--      <el-table-column label="销售订单号" align="center" prop="salesOrderId"/>-->
      <el-table-column :label="$t('common.option')" v-if="showBtn" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['pro:combination:edit']"
          >{{$t('修改')}}</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['pro:combination:remove']"
          >{{$t('删除')}}</el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改生产组合单对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">
        <el-form-item :label="$t('组合单号')" prop="combinationCode">
          <el-input v-model="form.combinationCode"/>
        </el-form-item>
        <el-form-item :label="$t('role.idx')" prop="combinationSort">
          <el-input v-model="form.combinationSort"/>
        </el-form-item>
        <el-form-item :label="$t('生产工单')" prop="workorderCode">
          <el-input v-model="form.workorderCode"/>
        </el-form-item>
        <el-form-item :label="$t('销售订单号')" prop="salesOrderNumber">
          <el-input v-model="form.salesOrderNumber"/>
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">{{ $t('common.confirm') }}</el-button>
        <el-button @click="cancel">{{ $t('common.cancel') }}</el-button>
      </div>
    </el-dialog>


    <el-dialog :title="$t('追加生产单')" :visible.sync="combOpen" width="800px" append-to-body @close="getList">
      <choose-workorder-for-comb :combinationCode="combinationCode"></choose-workorder-for-comb>
    </el-dialog>
  </div>
</template>

<script>


import {
  listCombination,
  getCombination,
  delCombination,
  addCombination,
  updateCombination, combList, batchAddCombination
} from "@/api/mes/pro/combination";
import {genCode} from "@/api/system/autocode/rule";
import ChooseWorkorderForComb from "@/views/mes/pro/combination/chooseWorkorderForComb.vue";

export default {
  name: "CombinationInfo",
  components: {ChooseWorkorderForComb},
  props: {
    combinationCode: {
      type: String,
      default: null
    },
    showBtn: {
      type: Boolean,
      default: true
    }
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      combOpen: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 生产组合单表格数据
      combinationList: [],
      selectedRows: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        combinationCode: null, combinationSort: null, workorderCode: null, salesOrderNumber: null
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        combinationCode: [
          {required: true, message: this.$t('组合单号不能为空'), trigger: "blur"}
        ], combinationSort: [
          {required: true, message: this.$t('序号不能为空'), trigger: "blur"}
        ], workorderCode: [
          {required: true, message: this.$t('生产工单不能为空'), trigger: "blur"}
        ]
      }
    };
  },
  watch: {
    combinationCode: {
      handler(newVal, oldVal) {
        console.log(newVal, 'newVal')
        this.$nextTick(() => {
          if (this.combinationCode != '' && this.combinationCode != null) {
            this.queryParams.combinationCode = this.combinationCode;
            this.getList();
          }
        })
      },
      immediate: true,
      deep: true
    }
  },
  created() {
    // this.getList();
  },
  methods: {
    changeCombination(combinationCode) {
      this.queryParams.combinationCode = combinationCode;
      this.getList();
    },
    handleChangeSort(item) {
      updateCombination({...item}).then(response => {
      });
    },
    async handleCombination() {
      let params = []

      const res = await delCombination(this.ids);
      this.selectedRows.forEach((item, index) => {
        params.push({
          combinationSort: index,
          workorderId: item.workorderId,
          workorderCode: item.workorderCode,
          salesOrderId: 0,
          combinationCode: null
        })
      });

      batchAddCombination(params).then(response => {
        this.$modal.msgSuccess(this.$t('新增组合单成功'));
        this.getList();
      });
    },
    genCode() {
      genCode('COMBINATION_CODE').then(response => {
        this.form.oqcCode = response;
      });
    },
    /** 查询生产组合单列表 */
    getList() {
      this.loading = true;
      listCombination(this.queryParams).then(response => {
        this.combinationList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },


    handleView(row) {
      this.reset();
      this.getList();
      const combinationCode = row.combinationCode;
      this.$router.push("/mes/pro/combination/info?combinationCode=" + combinationCode);
    },

    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        combinationId: null, combinationCode: null, combinationSort: null, workorderCode: null, salesOrderNumber: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.combinationId)
      this.single = selection.length !== 1
      this.selectedRows = selection;
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.combOpen = true;
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const combinationId = row.combinationId || this.ids
      getCombination(combinationId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = this.$t('修改生产组合单');
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.combinationId != null) {
            updateCombination(this.form).then(response => {
              this.$modal.msgSuccess(this.$t('common.edit_success'));
              this.open = false;
              this.getList();
            });
          } else {
            addCombination(this.form).then(response => {
              this.$modal.msgSuccess(this.$t('common.add_success'));
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const combinationIds = row.combinationId || this.ids;
      this.$modal.confirm(this.$t('common.confirm_del_data')).then(function () {
        return delCombination(combinationIds);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess(this.$t('common.del_success'));
      }).catch(() => {
      });
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('pro/combination/export', {
        ...this.queryParams
      }, `combination_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
